<template>
  <Dialog v-model="dialogVisible" :title="dialogTitle" width="700">
    <el-form
      ref="formRef"
      v-loading="formLoading"
      :model="formData"
      :rules="formRules"
      label-width="120px"
    >
      <el-row v-if="formData.parentTypeId !== 0">
        <el-col :span="24">
          <el-form-item label="父类型" prop="parentTypeId">
            <el-tree-select
              v-model="formData.parentTypeId"
              :data="typeOptions"
              :props="{ value: 'id', label: 'hardwareTypeName', children: 'children' }"
              placeholder="请选择父类型"
            />
          </el-form-item>
        </el-col>
      </el-row>
      <!--      <el-row>-->
      <!--        <el-col :span="18">-->
      <!--          <el-form-item label="硬件编号" prop="hardwareTypeCode">-->
      <!--            <el-input-->
      <!--              v-model="formData.hardwareTypeCode"-->
      <!--              placeholder="请输入硬件编号"-->
      <!--            />-->
      <!--          </el-form-item>-->
      <!--        </el-col>-->
      <!--        <el-col :span="6">-->
      <!--          <el-form-item label-width="30">-->
      <!--            <el-switch-->
      <!--              v-model="autoGenFlag"-->
      <!--              active-text="自动生成"-->
      <!--              @change="handleAutoGenChange"-->
      <!--            />-->
      <!--          </el-form-item>-->
      <!--        </el-col>-->
      <!--      </el-row>-->
      <el-form-item label="硬件名称" prop="hardwareTypeName">
        <el-input v-model="formData.hardwareTypeName" placeholder="请输入硬件名称" />
      </el-form-item>
      <el-form-item label="状态" prop="enableFlag">
        <el-radio-group v-model="formData.enableFlag">
          <el-radio label="y">启用</el-radio>
          <el-radio label="n">禁用</el-radio>
        </el-radio-group>
      </el-form-item>
      <el-row>
        <el-col :span="24">
          <el-form-item label="备注" prop="remark">
            <el-input v-model="formData.remark" type="textarea" placeholder="请输入内容" />
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>
    <template #footer>
      <el-button :disabled="formLoading" type="primary" @click="submitForm">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>

<script lang="ts" setup>
import * as HardwareTypeApi from '@/api/hw/type/hardwaretype/index'
// import { genCode } from '@/api/system/autocode/rule'
import { handleTree } from '@/utils/tree'
defineOptions({ name: 'HardwareTypeForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  parentTypeId: 0,
  ancestors: null,
  enableFlag: 'y',
  remark: null,
  createBy: null,
  createTime: null,
  updateBy: null,
  updateTime: null,
  hardwareTypeCode: '',
  hardwareTypeName: ''
})
const formRules = reactive({
  // hardwareTypeCode: [{ required: true, message: '硬件编号不能为空', trigger: 'blur' }],
  hardwareTypeName: [{ required: true, message: '硬件名称不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

// 类型树相关
const typeOptions = ref([])


// 自动生成编码
const autoGenFlag = ref(false)

  /** 获取类型树 */
const getTypeTree = async () => {
  try {
    const data = await HardwareTypeApi.listHardwareType({ pageNo: 1, pageSize: -1 })
    typeOptions.value  = handleTree(data.list,'id', 'parentTypeId')
  } catch (error) {
    console.error('获取岗位树选项失败:', error)
  }
}
/** 打开弹窗 */
const open = async (type: string, id?: number, parentTypeId?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 设置父级ID
  if (parentTypeId) {
    formData.value.parentTypeId = parentTypeId
  }
  await getTypeTree()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await HardwareTypeApi.getHardwareTypeInfo(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value
    if (formType.value === 'create') {
      await HardwareTypeApi.addHardwareType(data)
      message.success(t('common.createSuccess'))
    } else {
      await HardwareTypeApi.updateHardwareType(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 自动生成编码 */
// const handleAutoGenChange = async (val: boolean) => {
//   if (val) {
//     const res = await genCode('HARDWARE_TYPE_CODE')
//     formData.value.hardwareTypeCode = res.data
//   } else {
//     formData.value.hardwareTypeCode = ''
//   }
// }

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    parentTypeId: 0,
    ancestors: null,
    enableFlag: 'y',
    remark: null,
    createBy: null,
    createTime: null,
    updateBy: null,
    updateTime: null,
    hardwareTypeCode: '',
    hardwareTypeName: ''
  }
  formRef.value?.resetFields()
  autoGenFlag.value = false
}
</script>
